#include <acknex.h>
#include <default.c>

typedef struct { 
  var pos[2],vel[2],ang,alv,rWon,own,mdl,mdlShr;
} PLAYER;

PLAYER* Plr[4];
STRING* sTmp;
BMAP* bFld=NULL;
PANEL* pFld=NULL;
SOUND* sndCdn;
SOUND* sndCrh;
SOUND* sndPlrS;
SOUND* sndCmpS;
SOUND* sndStng;
SOUND* sndSGm;
SOUND* sndCsGm;
BMAP* bWScr;
BMAP* MScr;

int Rnd[5]={1,3,5,10,15},Ri=1;
int ArSiz[6]={0,4,9,15,18,27},Ai=3;
int Dfc[42]={0,3,75,45,6,9,2.5, 20,4.5,75,37,6,9,2.5, 37,6,75,30,6,12,2.7, 53,8,75,20,6,11.7,3.1, 66,10,75,15,4,14.4,3.7, 77}, Mstr,plrN,Di=2;
var PlrDat[56]={0,220,220,30,32,31,0,190,190,28,90,0,9,5, 230,0,230,36,38,37,200,0,200,28,214,9,7,175, 210,0,0,75,77,80,180,0,0,28,340,16,7,365, 0,180,0,82,28,83,0,150,0,9,450,23,8,515};
var Rndm(from,to){return(from+integer(random((to+1)-from)));}
void DrScrn();

int ClrPxl(BMAP* bBmap,var Fm,var* vecClr,int iPosX, int iPosY, int iRds, int CPass)
{
	int j,i=-1;
	COLOR* pClr={red=0;}
	
	if (iPosX-iRds>0 && iPosY-iRds>0 && iPosX+iRds<screen_size.x && iPosY+iRds<screen_size.y)
		while (i++<=iRds*2)
			for (j=0;j<=iRds*2;j++)
				if (!CPass) pixel_to_bmap(bBmap,iPosX-iRds+i,iPosY-iRds+j,pixel_for_vec(vecClr,100,Fm));
				else {
					if (pixel_to_vec(pClr,NULL,Fm,pixel_for_bmap(bBmap,iPosX-iRds+i,iPosY-iRds+j))||1)
					if (pClr.red==0 && pClr.green==0 && pClr.blue==0) return(1);}
}

var CrtBrd(BMAP* bBmap, VECTOR* a, VECTOR* b, VECTOR* c, VECTOR* d, int iRds, VECTOR* vecClr)
{
	var Fm=bmap_lock(bBmap,0),i=a.x-1;

	while (i++<=b.x) ClrPxl(bBmap,Fm,vecClr,i,a.y,iRds,0);
	if (i=c.x-1) while (i++<=d.x) ClrPxl(bBmap,Fm,vecClr,i,c.y,iRds,0);
	if (i=a.y-1) while (i++<=c.y) ClrPxl(bBmap,Fm,vecClr,a.x,i,iRds,0);
	if (i=b.y-1) while (i++<=d.y) ClrPxl(bBmap,Fm,vecClr,b.x,i,iRds,0);

	bmap_unlock(bBmap);
}

var Trace2d(BMAP* bBmap,var Fm,PLAYER* spPlr,int PlrId,int dist,var angS,var* TOfs,var Step)
{
	var cPos[2],FObs=0,i=0,j=(integer(angS/2)*(-1))-Step;

	if (*TOfs=0.1)
	while (j<angS/2)
		if (*TOfs+=i*sign(sinv((spPlr->ang+j)-spPlr->ang)))
		if ((i=-1)||(j+=Step))
		if (cPos[0]=spPlr->pos[0])
		if (cPos[1]=spPlr->pos[1])
		while (i++<dist)
			if (vec_add(cPos[0],vec_for_angle(nullvector,vector(spPlr->ang+j,0,0))))
			if (i>3)
				if (!ClrPxl(bFld, Fm, nullvector,cPos[0], cPos[1],4-Ai,1))
				if (FObs=1)
				break;
	return(FObs);
}

void PlrFunc(PLAYER* spPlr,int PlrId)
{	
	var sTme=total_ticks,Fm,BMv,tBuf=0,pBuf=0,aBuf=0,TurnTo,updateTime=0,vcm=-2,tempPos[2],tempPan[2],i;
	
	while (spPlr->alv){
		var Fm=bmap_lock(bFld,0);
		
		while (aBuf>=1 && spPlr->own==1){
			if (aBuf--)
			if (key_pressed(PlrDat[PlrId*14+4])) spPlr->ang+=Dfc[Di*7+5];
				else if (key_pressed(PlrDat[PlrId*14+3])) spPlr->ang-=Dfc[Di*7+5];}
		
		while (tBuf>=1){
			if (spPlr->own==2){
				if (Trace2d(bFld,Fm,spPlr,PlrId,50,75,&TurnTo,12)){
					if (Trace2d(bFld,Fm,spPlr,PlrId,100,358,&TurnTo,10)) spPlr->ang+=Dfc[Di*7+4]*sign(TurnTo);}
				else{
					if (total_ticks-updateTime>2.3*16){
						if (updateTime=total_ticks)
						if (vcm=-1)
						if (Rndm(0,10)<6){
							if ((vcm=Rndm(0,3))||1)
							while (Plr[vcm].own==0||!Plr[vcm].alv||vcm==PlrId)
								if (vcm++>3) vcm=0;}}
					if (vcm>=0){
						if (vec_add(vec_set(tempPos,vector(Plr[vcm].pos[0],Plr[vcm].pos[1],0)),vec_scale (vec_for_angle(nullvector,vector(Plr[vcm]->ang,0,0)), Rndm(75,115))))
						if (vec_sub(tempPos,vector(spPlr.pos[0],spPlr.pos[1],0)))
						if (vec_to_angle(tempPan,tempPos))
						spPlr->ang+=Dfc[Di*7+4]*sign(sinv((tempPan[0])-spPlr->ang));}
					else if (vcm==-1) spPlr->ang+=Dfc[Di*7+4]*sign(Rndm(-10,10));}}

			while (spPlr->ang>180||spPlr->ang<-180) spPlr->ang-=360*sign(spPlr->ang);
			
			if (vec_add(spPlr->vel[0],vec_for_angle(nullvector,vector(spPlr->ang,0,0)))||1)
			if ((BMv=0)||1)
			if (i=-1)
			while (i++<=1)
				if (abs(spPlr->vel[i])>1){
					if (spPlr->vel[i]-=sign(spPlr->vel[i]))
					if (spPlr->pos[i]+=sign(spPlr->vel[i]))
					BMv=1;}

			if (BMv){
				if (!ClrPxl(bFld, Fm, nullvector,spPlr->pos[0], spPlr->pos[1],4-Ai,1)||spPlr->pos[0]-(4-Ai)<=3
					 || spPlr->pos[1]-(4-Ai)<=3 || spPlr->pos[0]+(4-Ai)>=screen_size.x||spPlr->pos[1]+(4-Ai)>=screen_size.y)
					if (snd_play(sndCrh, 100, 0))
					spPlr->alv=0;

				if (pBuf++ || tBuf-- || 1)
					if (pBuf<=Dfc[Di*7+2]) ClrPxl(bFld, Fm, PlrDat[PlrId*14+0],spPlr->pos[0], spPlr->pos[1],4-Ai,0);
					else if (pBuf>Dfc[Di*7+2]+Dfc[Di*7+3]) pBuf=0;}}

		if (draw_quad(NULL,vector(spPlr->pos[0]-(4-Ai),spPlr->pos[1]-(4-Ai),0),NULL,vector(1+((4-Ai)*2),1+((4-Ai)*2),0),NULL,PlrDat[PlrId*14+0],100,0))
		if (bmap_unlock(bFld))
		if (wait(1))
		if (total_ticks-sTme<3*18) {if ((aBuf+=time_frame*0.3)||1) tBuf+=time_frame*0.3;}
			else {if ((aBuf+=time_frame*Dfc[Di*7+6])||1) tBuf+=time_frame*Dfc[Di*7+1];}
	}
}

STRING* PlrNm(var PlrId,STRING* PlrNames){
	return(str_trunc(str_clip(str_cpy(sTmp,PlrNames),PlrDat[PlrId*14+11]),str_len(PlrNames)-PlrDat[PlrId*14+11]-PlrDat[PlrId*14+12]));}

var Mtch()
{
	var AwTx[8]={35,396,84,396,82,82,335,335},sTme=total_ticks,winnerId=-2,i=-1,j,endTime,Medal=1,MdlShr;
	STRING* PlrNames=str_create("Mr YellowMr PinkMr BlueMr Green");

	if (ptr_remove(bFld)||1)
	if (ptr_remove(pFld)||1)
	if ((bFld=bmap_createblack(screen_size.x,screen_size.y,16))||1)
	if ((pFld=pan_create("bmap = bFld;flags=VISIBLE;",1))||1)
	if ((CrtBrd(bFld, vector(5,30,0), vector(634,30,0), vector(5,474,0), vector(634,474,0), 4-Ai, vector(0,0,206)))||1)
	while (i++<4){
		if (vec_set(Plr[i]->pos[0],vector(Rndm(40,600),Rndm(65,440),NULL)))
		if (vec_set(Plr[i]->vel[0],vector(0,0,NULL)))
		if ((Plr[i]->ang=Rndm(-180,180))||1)
		if (Plr[i]->alv=1)
		if (Plr[i]->own!=0) PlrFunc(Plr[i],i);}
	
	if (snd_play(sndCdn, 100, 0))
	while (winnerId==-2){
		if (!media_playing(media_handle)) media_play(str_cat_num(str_cpy(sTmp,""),"%.0f.mid",Rndm(1,12)),NULL,100);
		if (total_ticks-sTme<3*19) draw_text(str_for_num (NULL, abs(integer((total_ticks-sTme)/19)-3)),317,5,vector(0,255,255));

		if (i=-1)
		if (winnerId=-1)
		while (i++<4){
			if (Plr[i]->own!=0)
				if (draw_text(str_cat_num(str_cat_num(PlrNm(i,PlrNames),": %.0f",Plr[i]->rWon),"/%.0f",Rnd[Ri]),PlrDat[i*14+13],7,PlrDat[i*14+6]))
					if (Plr[i]->alv)
						if (winnerId==-1) winnerId=i;
							else winnerId=-2;}

		if (winnerId>=0) if (Plr[winnerId]->rWon++) Plr[winnerId]->alv=0;

		wait(1);}
	
	if (endTime=total_ticks)
	while (total_ticks-endTime<2*16){
		if (winnerId>=0) draw_text(str_cat(PlrNm(winnerId,PlrNames)," Wins!"),265,7,PlrDat[winnerId*14+6]);
			else draw_text("Tie!",305,7,vector(0,128,255));
		wait(1);}

	if (winnerId==-1) Mtch();
		else if (Plr[winnerId]->rWon<Rnd[Ri]) Mtch();
		else{
			if (draw_textmode("Arial",1,30,100))
			if (i=Rnd[Ri]+1)
			while (i-->=0){
				if (j=-1)
				if ((MdlShr=-1) || 1)
				while (j++<4)
					if (Plr[j].rWon==i && Plr[j].own!=0)
						if (MdlShr++ || 1)
						if (Plr[j].mdl=Medal)
						if (Plr[j].mdlShr=MdlShr)
						if (Plr[j].mdlShr==2) Plr[j].mdlShr=-1;
				if (MdlShr!=-1) Medal++;}

			if (media_stop(media_handle)||1)
			if (media_play("applause.ogg",NULL,10000))
			if (endTime=total_ticks)
			while (total_ticks-endTime<8*16){
				if (draw_quad(bWScr,nullvector,NULL,NULL,NULL,NULL,100,0))
				if (i=-1)
				while (i++<4)
					if (Plr[i].own!=0)
						draw_text(PlrNm(i,PlrNames),AwTx[Plr[i].mdl-1],AwTx[Plr[i].mdl-1+4]+Plr[i].mdlShr*30,PlrDat[i*14+6]);

				wait(1);}

			DrScrn();}
}

void TglRnd() {if (Mstr){}else if (snd_play(sndStng,100,0)) if (Ri++>4) Ri=0;}
void TglDfc() {if (Mstr){}else if (snd_play(sndStng,100,0)) if (Di++>4) Di=0;}
void TglArSiz() {if (Mstr){}else if (snd_play(sndStng,100,0)) if (Ai++>4) Ai=0;}
void Hesc(){if (proc_kill(16)||1) snd_stopall(4); if (Mstr) DrScrn(); else sys_exit("");}
void TglEnt()
{
	if (Mstr){}else{
	if (plrN<2) snd_play(sndCsGm,100,0);
	else
		if (media_stop(media_handle)||1)
		if (snd_play(sndSGm,100,0))
		if (wait(-0.6))
		if (Mtch())
		if (wait(1))
		Mstr=1;}
}

void DrScrn()
{	
	if (media_stop(media_handle)||1) media_loop("MeltyEyes.ogg",NULL,10000);

	int i=-1,bKey[4];
	STRING* sDfs=str_create("I Like my Lines SlowAre we there Yet?Just About RightMake it Stop!Impossible!");
	STRING* sArSizs=str_create("BabySmallMediumBigHumongous");

	while (i++<4) Plr[i]->own=0;

	if ((Mstr=0)||(plrN=0)||(draw_textmode("Arial",1,20,100)))
	while (!Mstr){
		if (draw_quad(MScr,nullvector,NULL,NULL,NULL,NULL,100,0))
		if (draw_text(str_for_num(NULL,Rnd[Ri]),415,284,vector(0,255,255)))
		if (draw_text(str_trunc(str_clip(str_cpy(sTmp,sDfs),Dfc[Di*7+0]),str_len(sDfs)-Dfc[Di*7+0]-(Dfc[(Di+1)*7+0]-Dfc[Di*7+0])),359,320,vector(255,0,255)))
		if (draw_text(str_trunc(str_clip(str_cpy(sTmp,sArSizs),ArSiz[Ai]),str_len(sArSizs)-ArSiz[Ai]-(ArSiz[Ai+1]-ArSiz[Ai])),356,354,vector(255,255,128)))
		if (i=-1)
		while (i++<4){
			if (key_pressed(PlrDat[i*14+5]) && !bKey[i]){
				if (Plr[i]->own==0) plrN++;

				if (bKey[i]=1)
				if ((Plr[i]->rWon=0) || 1)
				if (Plr[i]->own++>2) Plr[i]->own=1;

				if (Plr[i]->own==1) snd_play(sndPlrS,100,0);
					else snd_play(sndCmpS,100,0);}

			if (!key_pressed(PlrDat[i*14+5])) bKey[i]=0;

			if (Plr[i]->own==1) draw_text("Human",PlrDat[i*14+9]+45,PlrDat[i*14+10],PlrDat[i*14+6]);
				else if (Plr[i]->own==2) draw_text("Computer",PlrDat[i*14+9]+34,PlrDat[i*14+10],PlrDat[i*14+6]);
					else draw_text("Press Fire to Join!",PlrDat[i*14+9],PlrDat[i*14+10],PlrDat[i*14+6]);}

		wait(1);}
}

void main()
{	
	if (sndCdn=snd_create("countdown.ogg"))
	if (sndCrh=snd_create("crash.ogg"))
	if (sndPlrS=snd_create("joinPlr.wav"))
	if (sndCmpS=snd_create("joinComp.wav"))
	if (sndStng=snd_create("select.wav"))
	if (sndSGm=snd_create("Enter.wav"))
	if (sndCsGm=snd_create("noEnter.wav"))
	if (on_f1=TglRnd)
	if (on_f2=TglDfc)
	if (on_f3=TglArSiz)
	if (on_space=TglEnt)
	if (sTmp=str_create(""))
	if (bWScr=bmap_create("Winnerscreen.jpg"))
	MScr=bmap_create("Mainscreen.jpg");
	if (randomize() || video_switch (6,16,1)) mouse_pointer=0;

	int i=-1;
	while (i++<4) Plr[i]=malloc(sizeof(PLAYER));

	if (wait(1))
	if ((on_f5=NULL)||1||(on_esc=Hesc))
	DrScrn();
}